#!/usr/bin/mawk -f

function hex(v) {
	V="";if(v<0)v=0; if(v>255)v=255
	do {V=substr("0123456789abcdef",1+v%16,1) V;v=int(v/16)} while(v>0)
	if(length(V)==1)V="0"V
	return V
}

function p(r, g, b) { R=hex(r); G=hex(g); B=hex(b); printf s, "#"R G B, R, G, B}

BEGIN{
	printf "%s\n", "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
	printf "%s\n", "<ooo:color-table xmlns:office=\"urn:oasis:names:tc:opendocument:xmlns:office:1.0\" xmlns:draw=\"urn:oasis:names:tc:opendocument:xmlns:drawing:1.0\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" xmlns:svg=\"http://www.w3.org/2000/svg\" xmlns:ooo=\"http://openoffice.org/2004/office\">"

	s="<draw:color draw:name=\"%s\" draw:color=\"#%s%s%s\"/>\n"

#Every `step` value in the range [1...255] work,
# but you'll want a factor value of 255 (1 3 5 15 17 51 85) to get white (#ffffff) on the grayscale group and an even distribution on the last color of each others groups
# Factor value of 256 (1 2 4 8 16 32 64 128) work too to get white (#ffffff), as there is a hack that caps values at 255 in the hex function. The color distribution is off-by-one on the last color on each group though.
	step=17

	n=step*int(256/step)
	for(r=0; r<=n; r+=step) p(r, r, r)
	print ""
	
	r=255; for(b=g=0; g<=n; g+=step) p(r, g, b)
	g=255; for(r=n-step; r>0; r-=step) p(r, g, b)
			for(r=b=0; b<=n; b+=step) p(r, g, b)
	b=255; for(g=n-step; g>0; g-=step) p(r, g, b)
			for(g=r=0; r<=n; r+=step) p(r, g, b)
	r=255; for(b=n-step; b>0; b-=step) p(r, g, b)
	print ""

	for(l=step; l<n-1; l+=step) {
		r=l; for(b=g=0; g<=l; g+=step) p(r, g, b)
		g=l; for(r=l-step; r>0; r-=step) p(r, g, b)
			for(b=0; b<=l; b+=step) p(r, g, b)
		b=l; for(g=l-step; g>0; g-=step) p(r, g, b)
			for(r=0; r<=l; r+=step) p(r, g, b)
		r=l; for(b=l-step; b>0; b-=step) p(r, g, b)
	}
	print ""

	for(l=step; l<n-1; l+=step) {
		r=255; for(b=g=l; g<=n; g+=step) p(r, g, b)
		g=255; for(r=n-step; r>l; r-=step) p(r, g, b)
			for(r=b=l; b<=n; b+=step) p(r, g, b)
		b=255; for(g=n-step; g>l; g-=step) p(r, g, b)
			for(g=r=l; r<=n; r+=step) p(r, g, b)
		r=255; for(b=n-step; b>l; b-=step) p(r, g, b)
	}
	printf "%s\n", "</ooo:color-table>"

exit
}
